<script setup lang="ts">
  import { getTranslatedProperty } from '@shopware-pwa/helpers-next';
  import { PROMOTION_TYPE } from '~/helpers/constants';
  // import { OrderLineItem } from '@shopware-pwa/types';

  const { params } = useRoute();
  const orderId = params.id as string;
  const { getCountries } = useCountries();

  const {
    loadOrderDetails,
    shippingAddress,
    billingAddress,
    shippingMethod,
    order,
    subtotal,
    total,
    shippingCosts,
  } = useOrderDetails(orderId);

  const { sessionContext } = useSessionContext();
  const { paymentUrl, handlePayment, isAsynchronous, state, paymentMethod } =
    useOrderPayment(order);

  const tax = computed(() => {
    return (order.value?.price?.calculatedTaxes ?? []).reduce((sum, item) => sum + item.tax, 0);
  });
  const lineItems = computed(() => order.value?.lineItems || []);

  // TODO: implement total discount next phase
  // const totalDiscount = computed(() => {
  //   const appliedPromotionCodes = lineItems.value.filter(
  //     (lineItem: OrderLineItem) => lineItem.type === 'promotion',
  //   );
  //   if (!appliedPromotionCodes.length) return;
  //   return appliedPromotionCodes.reduce((total, item) => total + (item.totalPrice || 0), 0);
  // });

  onMounted(async () => {
    const SUCCESS_PAYMENT_URL = `${window?.location?.origin}/checkout/success/${orderId}/paid`;
    const FAILURE_PAYMENT_URL = `${window?.location?.origin}/checkout/success/${orderId}/unpaid`;

    await loadOrderDetails();
    handlePayment(SUCCESS_PAYMENT_URL, FAILURE_PAYMENT_URL);
  });

  watchDebounced(
    paymentUrl,
    (paymentUrl) => {
      if (typeof paymentUrl !== 'string') {
        return;
      }
      try {
        new URL(paymentUrl as string);
        window.location.href = paymentUrl;
      } catch (error) {
        console.error('err, redirect', error);
      }
    },
    { debounce: 5000 },
  );

  const goToUrl = (url: string | null) => {
    if (typeof window !== 'undefined' && url) {
      window.location.href = url;
    }
  };

  const getCountryNameFromId = (id?: string) => {
    if (!id) return;
    const country = getCountries.value.findLast((x) => x.id === id);
    return getTranslatedProperty(country, 'name');
  };
</script>

<template>
  <ClientOnly>
    <div class="mx-auto my-12 flex flex-col space-y-6 px-4 md:max-w-[70rem] md:space-y-12 md:px-0">
      <!-- Order state -->
      <SwEmptyState class="md:pb-16 md:pt-8">
        <div
          class="bg-background-raised text-information-subdued h-18 w-18 md:(h-24 w-24) mx-auto flex justify-center rounded-full"
        >
          <span class="i-sw-solid:party-horn m-auto p-0 text-3xl/none md:text-[2.5rem]/none" />
        </div>
        <span class="text-xl font-bold md:text-[1.75rem]/8">
          {{
            $t('checkout.success.header', {
              store: getTranslatedProperty(sessionContext?.salesChannel, 'name'),
            })
          }}
        </span>
        <div class="text-(sm information-subdued) md:text-lg/[1.625rem]">
          {{ $t('checkout.success.sublime') }}
          <p>
            {{ $t('checkout.success.orderNumber') }}
            <span class="text-information">{{ order?.orderNumber }}</span>
          </p>
        </div>
      </SwEmptyState>
      <div
        v-if="isAsynchronous && paymentUrl && state?.technicalName === 'open'"
        class="mb-4 mb-8 mt-8 rounded-lg bg-blue-100 p-4 text-sm text-blue-700 dark:bg-blue-200 dark:text-blue-800"
        role="alert"
      >
        <div class="w-full text-center">
          <span class="font-bold"> {{ $t('checkout.success.paymentProcessLabel') }}</span>
          {{ $t('checkout.success.paymentProcessInfo') }}
          <div>
            <button
              class="font-small bg-brand-primary hover:bg-brand-dark mt-4 rounded-md border border-transparent px-2 py-1 text-base text-white shadow-sm"
              @click="goToUrl(paymentUrl)"
            >
              {{ $t('checkout.goToPayment') }}
            </button>
          </div>
        </div>
      </div>
      <!-- Shipping and payment -->
      <div class="flex flex-col space-y-6 md:flex-row md:space-x-6 md:space-y-0">
        <!-- Shipping -->
        <div v-if="shippingAddress" class="flex flex-1 flex-col space-y-6">
          <span class="text-xl font-bold md:text-[1.75rem]/8">{{ $t('shipping') }}</span>
          <div class="bg-background-raised rounded-md p-4">
            <p class="pb-2 font-bold">{{ $t('checkout.shippingAddressLabel') }}</p>
            <div>{{ shippingAddress?.firstName }} {{ shippingAddress?.lastName }}</div>
            {{ shippingAddress?.street }}
            <div>{{ shippingAddress?.zipcode }} {{ shippingAddress?.city }}</div>
            {{ getCountryNameFromId(shippingAddress?.countryId) }}
          </div>
          <div v-if="shippingMethod" class="bg-background-raised rounded-md p-4">
            <p class="pb-2 font-bold">{{ $t('checkout.shippingMethodLabel') }}</p>
            {{ getTranslatedProperty(shippingMethod, 'name') }}
            <div v-if="shippingMethod?.deliveryTime">
              {{ $t('checkout.takesUpTo') }}
              {{ getTranslatedProperty(shippingMethod.deliveryTime, 'name') }}
            </div>
          </div>
        </div>
        <!-- Payment -->
        <div class="flex flex-1 flex-col space-y-6">
          <span class="text-xl font-bold md:text-[1.75rem]/8">{{ $t('payment') }}</span>
          <div v-if="billingAddress" class="bg-background-raised rounded-md p-4">
            <p class="pb-2 font-bold">{{ $t('checkout.billingAddressLabel') }}</p>
            <div>{{ billingAddress?.firstName }} {{ billingAddress?.lastName }}</div>
            {{ billingAddress?.street }}
            <div>{{ billingAddress?.zipcode }} {{ billingAddress?.city }}</div>
            {{ getCountryNameFromId(billingAddress?.countryId) }}
          </div>
          <div
            v-if="paymentMethod"
            class="bg-background-raised rounded-md p-4"
            :class="shippingMethod?.deliveryTime ? 'pb-10' : ''"
          >
            <p class="pb-2 font-bold">{{ $t('checkout.paymentMethodLabel') }}</p>
            {{ getTranslatedProperty(paymentMethod, 'name') }}
          </div>
        </div>
      </div>
      <!-- Summary -->
      <div class="bg-background-raised rounded-md p-6">
        <span class="text-xl font-bold md:text-[1.75rem]/8">{{ $t('checkout.summary') }}</span>
        <div v-for="item in lineItems" :key="item.id">
          <OrderLineItem readonly :data="item" :is-promote-code="item.type === PROMOTION_TYPE" />
        </div>

        <div class="flex justify-between pt-3 text-sm/6">
          <p>{{ $t('checkout.subtotal') }}</p>
          <SwPrice :value="subtotal" class="font-medium" :has-asterisk="false" />
        </div>

        <!-- <div v-if="totalDiscount" class="flex justify-between pt-1 text-sm/6">
          <p>{{ $t('cart.discounts') }}</p>
          <SwPrice
            :value="totalDiscount"
            class="font-medium text-emerald-900"
            :has-asterisk="false"
          />
        </div> -->
        <div class="flex justify-between pt-1 text-sm/6">
          <p>{{ $t('cart.tax') }}</p>
          <SwPrice :value="tax" class="text-success font-medium" :has-asterisk="false" />
        </div>
        <div class="flex justify-between border-b pb-3 pt-1 text-sm/6">
          <p>{{ $t('checkout.shippingPriceLabel') }}</p>
          <SwPrice :value="shippingCosts" class="font-medium" :has-asterisk="false" />
        </div>

        <div class="flex justify-between pt-3 text-lg/[1.625rem] font-semibold">
          <p>{{ $t('checkout.grandTotal') }}</p>
          <SwPrice :value="total" :has-asterisk="false" />
        </div>
      </div>
    </div>
  </ClientOnly>
</template>
